function Classroom(student_count, control_button) {
    // members
	var student = new Array();	
	var controlButton = control_button;
	// initialization
	for (i=0;i<student_count;i++) {
		student.push(0); //set each student to no permission to start
		//put the students in the classroom (three rows of students)
		document.getElementById('classroom').innerHTML += 
			'<div id="student' + i + '" style="position:absolute;top:' + (50+(i%3)*160) + 'px;left:' + Math.floor(i/3)*120 +'px;z-index:800"><img src="student_sitting.png" alt="student' + i + '" id="student_image' + i + '" onclick="classroom.gotpermission(' + i + ');"></div>';
	}
	// Subject object: Extend the controlling button with the Subject class
	extend(new Subject(), controlButton);
	// Clicking the button will trigger notifications to its observers
	controlButton["onclick"] = new Function("controlButton.notify(1)");
	//methods
	this.resetpermissions = function() {
		for(i=0;i<student.length;i++) {
			var object = document.getElementById("student" + i);
			controlButton.removeObserver(object);
			document.getElementById("student_image" + i).src = "student_sitting.png";
		}
	}

	this.gotpermission = function(student_index) {
		//alert(student_index);
		var object  = document.getElementById("student" + student_index);
		document.getElementById("student_image" + student_index).src = "student_slip.png";
		// Extend the student with the Observer class
		extend(new Observer(), object);
		// Override with update behavior
		object.update = function() {
			document.getElementById("student_image" + student_index).src = "student_handup.png";
		};
		// Add the new observer to our list of observers for our main subject
		controlButton.addObserver(object);
	}
}